//+------------------------------------------------------------------------+
//+------------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 EMPTY
#property indicator_color2 EMPTY
#property indicator_color3 Aqua 
#property indicator_width3 2
#property indicator_color4 EMPTY
#property indicator_color5 EMPTY
#property indicator_color6 Red
#property indicator_width6 2
#property indicator_color7 Lime
#property indicator_width7 2
#property indicator_style7 STYLE_SOLID

#property indicator_level1 85
#property indicator_level2 80
#property indicator_level3 50
#property indicator_level4 20
#property indicator_level5 15

#property indicator_levelcolor  OliveDrab//DarkOliveGreen

//
//
//
//
//

extern string TimeFrame    = "Current tiome frame";
extern int    RSI_Period   = 14;
extern int    SigMA_Period =  8;
extern int    SigMA_Mode   =  1;
extern int    Band_Period  = 18;  
extern bool   Interpolate  = true;

//
//
//
//
//

double RSIBuf[];
double SigMABuf[];
double MABuf[];
double UpZone[];
double DnZone[];
double UpZone1[];
double DnZone1[];

//
//
//
//
//

int    timeFrame;
string IndicatorFileName; 
bool   calculating;
bool   gettingBars;

//+---------------------------------------------------------------------------+
//|                                                                           |
//+---------------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,UpZone);
   SetIndexBuffer(1,UpZone1);
   SetIndexBuffer(2,MABuf);
   SetIndexBuffer(3,DnZone1);
   SetIndexBuffer(4,DnZone);
   SetIndexBuffer(5,SigMABuf);
   SetIndexBuffer(6,RSIBuf);
   
   calculating = (TimeFrame == "calculate"); if (calculating) return(0);
   gettingBars = (TimeFrame == "get bars");  if (gettingBars) return(0);

         SetIndexLabel(0,"");
         SetIndexLabel(1,"");
         SetIndexLabel(2,"MA");
         SetIndexLabel(3,"");
         SetIndexLabel(4,"");
         SetIndexLabel(5,"SigMA");
         SetIndexLabel(6,"RSI");

   //
   //
   //
   //
   //

   timeFrame = stringToTimeFrame(TimeFrame);
      IndicatorShortName("RSI with bands ["+timeFrameToString(timeFrame)+"] RSI ("+RSI_Period+") SigMA ("+SigMA_Period+") BB ("+Band_Period+") ");  
   IndicatorFileName = WindowExpertName();
   return(0);
}
int deinit() { return(0); }



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //   
   //
   //

      if (gettingBars) { UpZone[0] = limit; return(0); }
      if (calculating)
      {
         for(i=limit; i>=0; i--) RSIBuf[i] = iRSI(NULL,0,RSI_Period,PRICE_WEIGHTED,i);
         for(i=limit; i>=0; i--)
         {
            MABuf[i]    = iMAOnArray(RSIBuf,0,Band_Period,0,MODE_SMA,i);
            SigMABuf[i] = iMAOnArray(RSIBuf,0,SigMA_Period,0,SigMA_Mode,i);
            UpZone[i]   = iStdDevOnArray(RSIBuf,0,Band_Period,0,MODE_SMA,i);
         }         
         return(0);
      }
 
   //
   //
   //
   //
   //

   if (timeFrame > Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,IndicatorFileName,"get bars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);

         //
         //
         //
         //
         //
         
         double deviation   = iCustom(NULL,timeFrame,IndicatorFileName,"calculate",RSI_Period,SigMA_Period,SigMA_Mode,Band_Period,0,y);
                MABuf[i]    = iCustom(NULL,timeFrame,IndicatorFileName,"calculate",RSI_Period,SigMA_Period,SigMA_Mode,Band_Period,2,y);
                SigMABuf[i] = iCustom(NULL,timeFrame,IndicatorFileName,"calculate",RSI_Period,SigMA_Period,SigMA_Mode,Band_Period,5,y);
                RSIBuf[i]   = iCustom(NULL,timeFrame,IndicatorFileName,"calculate",RSI_Period,SigMA_Period,SigMA_Mode,Band_Period,6,y);
                UpZone[i]   = MABuf[i] + (1.3185 * deviation);
                DnZone[i]   = MABuf[i] - (1.3185 * deviation);  
                UpZone1[i]  = MABuf[i] + (0.382  * deviation);
                DnZone1[i]  = MABuf[i] - (0.382  * deviation);

         if(timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
         if(!Interpolate) continue;

         //
         //
         //
         //
         
		   datetime	time = iTime(NULL,timeFrame,y);
  		      for(int n = 1; i+n < Bars && Time[i+n]>=time; n++) continue;	
   		   double factor = 1.0 / n;
            for(int k = 1; k < n; k++)
               {
			         SigMABuf[i+k]  = k*factor*SigMABuf[i+n]  + (1.0-k*factor)*SigMABuf[i];
			         MABuf[i+k]     = k*factor*MABuf[i+n]     + (1.0-k*factor)*MABuf[i];
			         RSIBuf[i+k]    = k*factor*RSIBuf[i+n]    + (1.0-k*factor)*RSIBuf[i];
			         UpZone[i+k]    = k*factor*UpZone[i+n]    + (1.0-k*factor)*UpZone[i];
			         DnZone[i+k]    = k*factor*DnZone[i+n]    + (1.0-k*factor)*DnZone[i];
			         UpZone1[i+k]   = k*factor*UpZone1[i+n]   + (1.0-k*factor)*UpZone1[i];
			         DnZone1[i+k]   = k*factor*DnZone1[i+n]   + (1.0-k*factor)*DnZone1[i];
               }			         
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}